"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Variable_name, _Value_value, _ConditionMatcher_left, _ConditionMatcher_right, _ConditionMatcher_operator, _Rule_operation, _Rule_condition, _Segment_name, _Segment_variable, _Match_submatches, _Match_rules, _Match_segments, _Match_wildcard, _RuleRunner_root_matches;
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRuleRunner = exports.RuleRunner = exports.CompilerError = void 0;
class CompilerError extends Error {
    constructor(message, node) {
        super(message);
        this.node = node;
    }
}
exports.CompilerError = CompilerError;
class Variable {
    constructor(name) {
        _Variable_name.set(this, void 0);
        __classPrivateFieldSet(this, _Variable_name, name, "f");
    }
    getValue(variables) {
        const parts = __classPrivateFieldGet(this, _Variable_name, "f").split(".");
        let current = variables;
        while (parts.length > 0) {
            const name = parts.shift();
            if (current && typeof current == "object")
                current = current[name];
        }
        return current;
    }
}
_Variable_name = new WeakMap();
class Value {
    constructor(value) {
        _Value_value.set(this, void 0);
        __classPrivateFieldSet(this, _Value_value, value, "f");
    }
    get value() {
        return __classPrivateFieldGet(this, _Value_value, "f");
    }
}
_Value_value = new WeakMap();
class ConditionMatcher {
    constructor(left, right, operator) {
        _ConditionMatcher_left.set(this, void 0);
        _ConditionMatcher_right.set(this, void 0);
        _ConditionMatcher_operator.set(this, void 0);
        __classPrivateFieldSet(this, _ConditionMatcher_left, left, "f");
        __classPrivateFieldSet(this, _ConditionMatcher_right, right, "f");
        __classPrivateFieldSet(this, _ConditionMatcher_operator, operator, "f");
    }
    test(variables) {
        let leftValue;
        if (__classPrivateFieldGet(this, _ConditionMatcher_left, "f") instanceof Value) {
            leftValue = __classPrivateFieldGet(this, _ConditionMatcher_left, "f").value;
        }
        else if (__classPrivateFieldGet(this, _ConditionMatcher_left, "f") instanceof Variable) {
            leftValue = __classPrivateFieldGet(this, _ConditionMatcher_left, "f").getValue(variables);
        }
        else {
            leftValue = __classPrivateFieldGet(this, _ConditionMatcher_left, "f").test(variables);
        }
        let rightValue;
        if (__classPrivateFieldGet(this, _ConditionMatcher_right, "f") instanceof Value) {
            rightValue = __classPrivateFieldGet(this, _ConditionMatcher_right, "f").value;
        }
        else if (__classPrivateFieldGet(this, _ConditionMatcher_right, "f") instanceof Variable) {
            rightValue = __classPrivateFieldGet(this, _ConditionMatcher_right, "f").getValue(variables);
        }
        else {
            rightValue = __classPrivateFieldGet(this, _ConditionMatcher_right, "f").test(variables);
        }
        switch (__classPrivateFieldGet(this, _ConditionMatcher_operator, "f")) {
            case "==":
                return leftValue == rightValue;
            case "!=":
                return leftValue != rightValue;
            case ">=":
                return leftValue >= rightValue;
            case "<=":
                return leftValue <= rightValue;
            case ">":
                return leftValue > rightValue;
            case "<":
                return leftValue < rightValue;
            case "&&":
                return leftValue && rightValue;
            case "||":
                return leftValue || rightValue;
            default:
                throw new Error("Invalid operator " + __classPrivateFieldGet(this, _ConditionMatcher_operator, "f"));
        }
    }
}
_ConditionMatcher_left = new WeakMap(), _ConditionMatcher_right = new WeakMap(), _ConditionMatcher_operator = new WeakMap();
class Rule {
    constructor(operation, condition) {
        _Rule_operation.set(this, void 0);
        _Rule_condition.set(this, void 0);
        __classPrivateFieldSet(this, _Rule_operation, operation, "f");
        __classPrivateFieldSet(this, _Rule_condition, condition, "f");
    }
    get operation() {
        return __classPrivateFieldGet(this, _Rule_operation, "f");
    }
    test(variables) {
        if (__classPrivateFieldGet(this, _Rule_condition, "f") instanceof Value) {
            return Boolean(__classPrivateFieldGet(this, _Rule_condition, "f").value);
        }
        else if (__classPrivateFieldGet(this, _Rule_condition, "f") instanceof Variable) {
            return Boolean(__classPrivateFieldGet(this, _Rule_condition, "f").getValue(variables));
        }
        else {
            return __classPrivateFieldGet(this, _Rule_condition, "f").test(variables);
        }
    }
}
_Rule_operation = new WeakMap(), _Rule_condition = new WeakMap();
class Segment {
    constructor(name, variable = false) {
        _Segment_name.set(this, void 0);
        _Segment_variable.set(this, void 0);
        __classPrivateFieldSet(this, _Segment_name, name, "f");
        __classPrivateFieldSet(this, _Segment_variable, variable, "f");
    }
    get name() {
        return __classPrivateFieldGet(this, _Segment_name, "f");
    }
    match(segment) {
        return {
            match: __classPrivateFieldGet(this, _Segment_name, "f") === segment || __classPrivateFieldGet(this, _Segment_variable, "f"),
            variable: __classPrivateFieldGet(this, _Segment_variable, "f") && __classPrivateFieldGet(this, _Segment_name, "f"),
        };
    }
}
_Segment_name = new WeakMap(), _Segment_variable = new WeakMap();
class Match {
    constructor(segments, rules, wildcard, submatches) {
        _Match_submatches.set(this, void 0);
        _Match_rules.set(this, void 0);
        _Match_segments.set(this, void 0);
        _Match_wildcard.set(this, void 0);
        __classPrivateFieldSet(this, _Match_segments, segments, "f");
        __classPrivateFieldSet(this, _Match_rules, rules, "f");
        __classPrivateFieldSet(this, _Match_wildcard, wildcard, "f");
        __classPrivateFieldSet(this, _Match_submatches, submatches, "f");
    }
    match(segments, operation, variables) {
        let localVars = { ...variables };
        if (segments.length >= __classPrivateFieldGet(this, _Match_segments, "f").length) {
            for (let i = 0; i < __classPrivateFieldGet(this, _Match_segments, "f").length; i++) {
                const match = __classPrivateFieldGet(this, _Match_segments, "f")[i].match(segments[i]);
                if (match.match) {
                    if (match.variable) {
                        localVars[match.variable] = segments[i];
                    }
                }
                else {
                    return false;
                }
            }
            let remaining = segments.slice(__classPrivateFieldGet(this, _Match_segments, "f").length);
            if (remaining.length > 0 && !__classPrivateFieldGet(this, _Match_wildcard, "f")) {
                for (const match of __classPrivateFieldGet(this, _Match_submatches, "f")) {
                    const res = match.match(remaining, operation, localVars);
                    if (res)
                        return true;
                }
            }
            else {
                for (const rule of __classPrivateFieldGet(this, _Match_rules, "f")) {
                    if (rule.operation === operation) {
                        if (rule.test(localVars))
                            return true;
                    }
                }
            }
        }
        return false;
    }
}
_Match_submatches = new WeakMap(), _Match_rules = new WeakMap(), _Match_segments = new WeakMap(), _Match_wildcard = new WeakMap();
class RuleRunner {
    constructor(root_matches) {
        _RuleRunner_root_matches.set(this, void 0);
        __classPrivateFieldSet(this, _RuleRunner_root_matches, root_matches, "f");
    }
    hasPermission(path, operation, request) {
        if (request.root)
            return true;
        for (const match of __classPrivateFieldGet(this, _RuleRunner_root_matches, "f")) {
            const res = match.match(path, operation, { request });
            if (res)
                return true;
        }
        return false;
    }
}
exports.RuleRunner = RuleRunner;
_RuleRunner_root_matches = new WeakMap();
function getRuleRunner(service) {
    const createMatch = (s_match) => {
        let wildcard = false;
        let segments = s_match.path.segments
            .map((segment, idx, arr) => {
            if (typeof segment === "string") {
                if (segment === "*") {
                    if (idx === arr.length - 1) {
                        wildcard = true;
                        return null;
                    }
                    else {
                        throw new CompilerError("Invalid path wildcard!", s_match);
                    }
                }
                else {
                    return new Segment(segment, false);
                }
            }
            else {
                return new Segment(segment.name, true);
            }
        })
            .filter((e) => e !== null);
        const resolveParameter = (e) => {
            let val;
            if (e.type === "value") {
                const c = e;
                if (c.isFalse) {
                    val = new Value(false);
                }
                else if (c.isTrue) {
                    val = new Value(true);
                }
                else if (c.isNull) {
                    val = new Value(null);
                }
                else if (c.isNumber) {
                    val = new Value(Number(c.value));
                }
                else if (c.isString) {
                    val = new Value(String(c.value));
                }
                else if (c.isVariable) {
                    val = new Variable(String(c.value));
                }
                else {
                    throw new CompilerError("Invalid value type!", e);
                }
            }
            else {
                val = createCondition(e);
            }
            return val;
        };
        const createCondition = (cond) => {
            let left = resolveParameter(cond.left);
            let right = resolveParameter(cond.right);
            return new ConditionMatcher(left, right, cond.operator);
        };
        const rules = s_match.rules
            .map((rule) => {
            const condition = resolveParameter(rule.condition);
            return rule.operations.map((op) => new Rule(op, condition));
        })
            .flat(1);
        const submatches = s_match.matches.map((sub) => createMatch(sub));
        const match = new Match(segments, rules, wildcard, submatches);
        return match;
    };
    const root_matches = service.matches.map((match) => createMatch(match));
    const runner = new RuleRunner(root_matches);
    return runner;
}
exports.getRuleRunner = getRuleRunner;
//# sourceMappingURL=compile.js.map