"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformError = void 0;
function indexToLineAndCol(src, index) {
    let line = 1;
    let col = 1;
    for (let i = 0; i < index; i++) {
        if (src.charAt(i) === "\n") {
            line++;
            col = 1;
        }
        else {
            col++;
        }
    }
    return { line, col };
}
function transformError(err, data, idx) {
    let loc = indexToLineAndCol(data, idx);
    return {
        line: loc.line,
        column: loc.col,
        message: err.message,
        original_err: err,
    };
}
exports.transformError = transformError;
//# sourceMappingURL=error.js.map