export declare type TokenTypes = "space" | "comment" | "string" | "keyword" | "colon" | "semicolon" | "comma" | "comparison_operator" | "logic_operator" | "equals" | "slash" | "bracket_open" | "bracket_close" | "curly_open" | "curly_close" | "array" | "questionmark" | "number" | "text";
export declare type Token = {
    type: TokenTypes;
    value: string;
    startIdx: number;
    endIdx: number;
};
export declare class TokenizerError extends Error {
    index: number;
    constructor(message: string, index: number);
}
export default function tokenize(input: string): Token[];
